//+------------------------------------------------------------------+
//|                                            TickScalper_v3.44.mq4 |
//|                             Copyright  2009-10, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009-10, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#include <stdlib.mqh>
//#include <MyEABase.mqh>

extern int TakeProfit = 0;
extern int StopLoss = 0;
extern int Magic = 0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
if (Digits==3 || Digits==5)
{
TakeProfit=TakeProfit*10;
StopLoss=StopLoss*10;
}

//---- 
  //InitLib();
//----
   return(0);
}

int _T = 1;
int _K = 2;
//int _C = 3;
int _KU = 3;
int _KD = 4; //Kumo Down


int TradeSignal(int tf) //Period
{   

int Signal =0;

int KumoDir = GetTKumoDir(tf, 1);
int KumoOld = GetTKumoDir(tf, 2);

int TKDir=GetTKDir(tf, 1);
int TKOld=GetTKDir(tf, 2);

double UpperKumo = GetUpperKumo(tf, 1);
double LowerKumo = GetLowerKumo(tf, 1);

if (TKDir==1)
  if (Close[1]>UpperKumo && Close[1]>GetIshi(tf, _K, 1))
    if(TKDir!=TKOld || (KumoDir!=KumoOld && KumoDir==1))
      Signal=1;
      
if (TKDir==-1)
  if (Close[1]<UpperKumo && Close[1]<GetIshi(tf, _K, 1))
    if(TKDir!=TKOld || (KumoDir!=KumoOld && KumoDir==-1))
      Signal=-1;
      
   return(Signal);
}

int TradeDirection(int tf)
{   

int Signal =0;

int KumoDir = GetTKumoDir(tf, 1);
int TKDir=GetTKDir(tf, 1);

double UpperKumo = GetUpperKumo(tf, 1);
double LowerKumo = GetLowerKumo(tf, 1);

if (TKDir==1)
  if (Close[1]>UpperKumo && Close[1]>GetIshi(tf, _K, 1))
    if(KumoDir==1)
      Signal=1;
      
if (TKDir==-1)
  if (Close[1]<UpperKumo && Close[1]<GetIshi(tf, _K, 1))
    if(KumoDir==-1)
      Signal=-1;
      
   return(Signal);
}

double GetUpperKumo(int tf, int i)
{
  return(MathMax(GetIshi(tf, _KU, i), GetIshi(tf, _KD, i)));
}

double GetLowerKumo(int tf, int i)
{
  return(MathMin(GetIshi(tf, _KU, i), GetIshi(tf, _KD, i)));
}

int GetTKumoDir(int tf, int i)
{
  double T = GetIshi(tf, _T, i);
  double Kumo_UP = GetUpperKumo(tf, i);
  double Kumo_DN = GetLowerKumo(tf, i);
  if(T>Kumo_UP) return(1);
  if(T<Kumo_DN) return(-1);
  return(0);
}

int GetTKDir(int tf, int i)
{
  double T = GetIshi(tf, _T, i);
  double K = GetIshi(tf, _K, i);
  if (T>K) return(1);
  if (T<K) return(-1);
  return(0);
}

double GetIshi(int tf, int Mode, int shift)
{
  return (iIchimoku(NULL,tf, 9,26,52, Mode, shift)); 
}

void ChartComment()
{
//   string sComment   = GetLibComment();
   
//   Comment(sComment);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+


int start()
{

  //Signal = 0;
  int Signal = 0;
  
  Signal=TradeSignal(0);
  int dir=Signal;
  //int dir=TradeDirection(PERIOD_H4);
  //if (Signal!=dir) Signal=0;
  //if (StartLib()==-1) return(0);
  //return(0);

  //if (Signal==-1)Signal=0;
  if(Signal==1 && dir==Signal)
  {
    int ticket = OrderSend(Symbol(),OP_BUY,0.1,Ask, 5,0,0,"",Magic);
    double tp = 0;
    if (TakeProfit>0) tp=Ask+TakeProfit*Point;
    ticket=OrderModify(ticket, Ask, Ask-StopLoss*Point, tp, 0);
    //BEvent=0;
  }

  if(Signal==-1 && dir==Signal)
  {
    ticket = OrderSend(Symbol(),OP_SELL,0.1,Bid, 5,0,0,"",Magic);
    tp = 0;
    if (TakeProfit>0) tp=Bid-TakeProfit*Point;
    ticket=OrderModify(ticket, Bid, Bid+StopLoss*Point, tp, 0);
    //BEvent=0;
  }
  //if(BreakEven > 0 || TrailingMode>0) TrailStop();

/*  int total = OrdersTotal();
  for(int order=total-1; order>=0;order--)
  {
    OrderSelect(order, SELECT_BY_POS);
    if (OrderType()==OP_BUY)
    {
      double NewSL = NormalizeDouble(MarketInfo(Symbol(),MODE_BID) - TrailingStop*_Point,Digits);
      //double currentSL = NormalizeDouble(OrderOpenPrice() + BreakEven*_Point,Digits);
      if (OrderStopLoss()>=OrderOpenPrice() || Bid > OrderOpenPrice()+TrailingStop*_Point)
      //if (OrderStopLoss()>=OrderOpenPrice())
      if ( NewSL > NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0)
      {
        OrderModify(OrderTicket(), OrderOpenPrice(), NewSL, OrderTakeProfit(), 0);
      }
    }


    if (OrderType()==OP_SELL)
    {
      NewSL = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK) + TrailingStop*_Point,Digits);
      if (OrderStopLoss()<=OrderOpenPrice() || Ask < OrderOpenPrice()-TrailingStop*_Point)
      if ( NewSL < NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0)
      {
        OrderModify(OrderTicket(), OrderOpenPrice(), NewSL, OrderTakeProfit(), 0);
      }
    }

  }*/
  
  
} //start()
//+------------------------------------------------------------------+


